Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4ContinuumGammaTransition.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4ContinuumGammaTransition.cc	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4ContinuumGammaTransition.cc	(revision 1340)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-//
+// $Id: G4ContinuumGammaTransition.cc,v 1.4 2010/10/07 07:50:13 mkelsey Exp $
 // -------------------------------------------------------------------
 //      GEANT 4 class file 
@@ -42,5 +42,5 @@
 //              Added creation time evaluation for products of evaporation
 //        02 May 2003,   Vladimir Ivanchenko change interface to G4NuclearlevelManager
-//      
+//        06 Oct 2010, M. Kelsey -- follow changes to G4NuclearLevelManager
 // -------------------------------------------------------------------
 //
@@ -63,15 +63,13 @@
   _nucleusA(A), _nucleusZ(Z), _excitation(excitation), _levelManager(levelManager) 
 {
-  const G4PtrLevelVector* levels = _levelManager->GetLevels();
   G4double eTolerance = 0.;
-  if (levels != 0)
-  {
-    G4int lastButOne = _levelManager->NumberOfLevels() - 2;
-    if (lastButOne >= 0)
-    {
-      eTolerance = _levelManager->MaxLevelEnergy() - levels->operator[](lastButOne)->Energy();
+  G4int lastButOne = _levelManager->NumberOfLevels() - 2;
+  if (lastButOne >= 0)
+    {
+      eTolerance = (_levelManager->MaxLevelEnergy() -
+		    _levelManager->GetLevel(lastButOne)->Energy());
       if (eTolerance < 0.) eTolerance = 0.;
     }
-  }
+  
 
   _verbose = verbose;
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4DiscreteGammaDeexcitation.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4DiscreteGammaDeexcitation.cc	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4DiscreteGammaDeexcitation.cc	(revision 1340)
@@ -25,5 +25,5 @@
 //
 // $Id: G4DiscreteGammaDeexcitation.cc,v 1.15 2010/05/10 07:20:40 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 // -------------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4DiscreteGammaTransition.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4DiscreteGammaTransition.cc	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4DiscreteGammaTransition.cc	(revision 1340)
@@ -56,5 +56,5 @@
 //              Removed unphysical corretions of gamma energy; fixed default particle 
 //              as gamma; do not subtract bounding energy in case of electron emmision
-//      
+//
 // -------------------------------------------------------------------
 
@@ -63,4 +63,5 @@
 #include "G4RandGeneralTmp.hh"
 #include "G4AtomicShells.hh"
+#include "G4NuclearLevel.hh"
 //JMQ: 
 #include "G4NuclearLevelStore.hh"
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4E1Probability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4E1Probability.cc	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4E1Probability.cc	(revision 1340)
@@ -26,5 +26,5 @@
 //
 // $Id: G4E1Probability.cc,v 1.9 2010/05/25 10:47:24 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 //---------------------------------------------------------------------
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4NeutronRadCapture.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4NeutronRadCapture.cc	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4NeutronRadCapture.cc	(revision 1340)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4NeutronRadCapture.cc,v 1.4 2009/12/16 17:51:11 gunter Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4NeutronRadCapture.cc,v 1.5 2010/09/09 15:40:48 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-ref-09 $
 //
 //
@@ -33,5 +33,5 @@
 //  
 // Modified:
-//
+// 09.09.2010 V.Ivanchenko added usage of G4PhotonEvaporation 
 //
 
@@ -56,6 +56,6 @@
   SetMinEnergy( 0.0*GeV );
   SetMaxEnergy( 100.*TeV );
-  //  photonEvaporation = new G4PhotonEvaporation();
-  photonEvaporation = 0;
+  photonEvaporation = new G4PhotonEvaporation();
+  //photonEvaporation = 0;
 }
 
@@ -66,10 +66,10 @@
 
 G4HadFinalState* G4NeutronRadCapture::ApplyYourself(
-		 const G4HadProjectile& aTrack, G4Nucleus& targetNucleus)
+		 const G4HadProjectile& aTrack, G4Nucleus& theNucleus)
 {
   theParticleChange.Clear();
 
-  G4int Z = static_cast<G4int>(targetNucleus.GetZ()+0.5);
-  G4int A = static_cast<G4int>(targetNucleus.GetN()+0.5);
+  G4int A = theNucleus.GetA_asInt();
+  G4int Z = theNucleus.GetZ_asInt();
 
   // Create initial state
@@ -77,84 +77,36 @@
   G4LorentzVector lv0(0.0,0.0,0.0,m1);   
   G4LorentzVector lv1 = aTrack.Get4Momentum() + lv0;
-  G4ThreeVector bst = lv1.boostVector();
-  G4double M  = lv1.mag();
 
-  ++A;
-  G4double m2 = G4NucleiProperties::GetNuclearMass(A, Z);
-  if(M - m2 <= lowestEnergyLimit) {
-    return &theParticleChange;
-  }
+  // simplified method of 1 gamma emission
+  if(A <= 3) {
 
-  if (verboseLevel > 1) {
-    G4cout << "G4NeutronRadCapture::DoIt: Eini(MeV)=" 
-	   << aTrack.GetKineticEnergy()/MeV << "  Eexc(MeV)= " 
-	   << (M - m2)/MeV 
-	   << "  Z= " << Z << "  A= " << A << G4endl;
-  }
+    G4ThreeVector bst = lv1.boostVector();
+    G4double M  = lv1.mag();
 
-  G4double e1 = (M - m2)*(M + m2)/(2*M);
-  G4double cost = 2.0*G4UniformRand() - 1.0;
-  if(cost > 1.0) {cost = 1.0;}
-  else if(cost < -1.0) {cost = -1.0;}
-  G4double sint = std::sqrt((1. - cost)*(1.0 + cost));
-  G4double phi  = G4UniformRand()*CLHEP::twopi;
-  G4LorentzVector lv2(e1*sint*std::cos(phi),e1*sint*std::sin(phi),e1*cost,e1);   
-  lv2.boost(bst);
-  theParticleChange.AddSecondary(new G4DynamicParticle(G4Gamma::Gamma(), lv2));
-  G4ParticleDefinition* theDef = 0;
+    ++A;
+    G4double m2 = G4NucleiProperties::GetNuclearMass(A, Z);
+    if(M - m2 <= lowestEnergyLimit) {
+      return &theParticleChange;
+    }
+ 
+    if (verboseLevel > 1) {
+      G4cout << "G4NeutronRadCapture::DoIt: Eini(MeV)=" 
+	     << aTrack.GetKineticEnergy()/MeV << "  Eexc(MeV)= " 
+	     << (M - m2)/MeV 
+	     << "  Z= " << Z << "  A= " << A << G4endl;
+    }
+    G4double e1 = (M - m2)*(M + m2)/(2*M);
+    G4double cost = 2.0*G4UniformRand() - 1.0;
+    if(cost > 1.0) {cost = 1.0;}
+    else if(cost < -1.0) {cost = -1.0;}
+    G4double sint = std::sqrt((1. - cost)*(1.0 + cost));
+    G4double phi  = G4UniformRand()*CLHEP::twopi;
+    G4LorentzVector lv2(e1*sint*std::cos(phi),e1*sint*std::sin(phi),e1*cost,e1);
+    lv2.boost(bst);
+    theParticleChange.AddSecondary(new G4DynamicParticle(G4Gamma::Gamma(), lv2));
+    G4ParticleDefinition* theDef = 0;
 
-  lv1 -= lv2; 
-  if(Z > 2 || A > 4) 
-    {
-      theDef = G4ParticleTable::GetParticleTable()->FindIon(Z,A,0,Z);
-    }
-  else if (Z == 1 && A == 2) {theDef = G4Deuteron::Deuteron();}
-  else if (Z == 1 && A == 3) {theDef = G4Triton::Triton();}
-  else if (Z == 2 && A == 3) {theDef = G4He3::He3();}
-  else if (Z == 2 && A == 4) {theDef = G4Alpha::Alpha();}
-
-  if (verboseLevel > 1) {
-    G4cout << "Gamma 4-mom: " << lv2 << "   " 
-	   << theDef->GetParticleName() << "   " << lv1 << G4endl;
-  }
-  if(theDef) {
-    theParticleChange.AddSecondary(new G4DynamicParticle(theDef, lv1));
-  }
-  
-  /*
-  // Create fragment in its rest frame
-  lv1.boost(-bst);
-  G4Fragment aNucleus(A+1, Z, lv1);
-  if(aNucleus.GetExcitationEnergy() <= lowestEnergyLimit) {
-    return &theParticleChange;
-  }
-
-  if (verboseLevel > 1) {
-    G4cout << "G4NeutronRadCapture::DoIt: Eini(MeV)=" 
-	   << aTrack.GetKineticEnergy()/MeV << "  Eexc(MeV)= " 
-	   << lv1.e() - G4NucleiProperties::GetNuclearMass(A+1, Z) 
-	   << "  Z= " << Z << "  A= " << A + 1 << G4endl;
-  }
-
-  //
-  // Sample final state
-  //
-
-  G4FragmentVector* fv = photonEvaporation->BreakItUp(aNucleus);
-  size_t n = fv->size();
-
-  if (verboseLevel > 1) {
-    G4cout << "G4NeutronRadCapture: " << n << " final particle" << G4endl;
-  }
-  for(size_t i=0; i<n; ++i) {
-    G4Fragment* f = (*fv)[i];    
-    G4LorentzVector lvres = f->GetMomentum();   
-    lvres.boost(bst);
-    G4int Z = G4int(f->GetZ() + 0.5);
-    G4int A = G4int(f->GetA() + 0.5);
-
-    G4ParticleDefinition* theDef = 0;
-    if(0 == Z && 0 == A) {theDef =  f->GetParticleDefinition();}
-    else if(Z > 2 || A > 4) 
+    lv1 -= lv2; 
+    if(Z > 2 || A > 4) 
       {
 	theDef = G4ParticleTable::GetParticleTable()->FindIon(Z,A,0,Z);
@@ -166,13 +118,56 @@
 
     if (verboseLevel > 1) {
-      G4cout << i << ". " << theDef->GetParticleName()
-	     << "   " << lvres << G4endl;
+      G4cout << "Gamma 4-mom: " << lv2 << "   " 
+	     << theDef->GetParticleName() << "   " << lv1 << G4endl;
     }
     if(theDef) {
-      theParticleChange.AddSecondary(new G4DynamicParticle(theDef, lvres));
+      theParticleChange.AddSecondary(new G4DynamicParticle(theDef, lv1));
     }
-    delete f;
+ 
+  // Use photon evaporation  
+  } else {
+ 
+    G4Fragment aFragment(A+1, Z, lv1);
+
+    if (verboseLevel > 1) {
+      G4cout << "G4NeutronRadCapture::ApplyYourself initial G4Fragmet:" << G4endl;
+      G4cout << aFragment << G4endl;
+    }
+
+    //
+    // Sample final state
+    //
+    G4FragmentVector* fv = photonEvaporation->BreakUpFragment(&aFragment);
+    if(fv) {
+      size_t n = fv->size();
+
+      if (verboseLevel > 1) {
+	G4cout << "G4NeutronRadCapture: " << n << " final particle" << G4endl;
+      }
+      for(size_t i=0; i<n; ++i) {
+	G4Fragment* f = (*fv)[i];    
+	G4LorentzVector lvres = f->GetMomentum();   
+	Z = f->GetZ_asInt();
+	A = f->GetA_asInt();
+
+	G4ParticleDefinition* theDef = 0;
+	if(0 == Z && 0 == A) {theDef =  f->GetParticleDefinition();}
+	else
+	  {
+	    theDef = G4ParticleTable::GetParticleTable()->FindIon(Z,A,0,Z);
+	  }
+
+	if (verboseLevel > 1) {
+	  G4cout << i << ". " << theDef->GetParticleName()
+		 << "   " << lvres << G4endl;
+	}
+	if(theDef) {
+	  theParticleChange.AddSecondary(new G4DynamicParticle(theDef, lvres));
+	}
+	delete f;
+      }
+      delete fv;
+    }
   }
-  */
   return &theParticleChange;
 }
Index: trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4NuclearLevel.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4NuclearLevel.cc	(revision 1337)
+++ trunk/source/processes/hadronic/models/de_excitation/photon_evaporation/src/G4NuclearLevel.cc	(revision 1340)
@@ -24,5 +24,5 @@
 // ********************************************************************
 //
-//
+// $Id: G4NuclearLevel.cc,v 1.5 2010/10/10 23:01:39 mkelsey Exp $
 // -------------------------------------------------------------------
 //      GEANT 4 class file 
@@ -39,4 +39,7 @@
 //
 //      Modifications: 
+//	  06 Oct 2010, M. Kelsey (kelsey@slac.stanford.edu)
+//		Add friendship for G4NuclearLevelManager; define private
+//		constructors without vectors.
 //
 //        09 Sep. 2002, Fan Lei  (flei@space.qinetiq.com)
@@ -63,4 +66,16 @@
   instanceCount+=aF;
   return instanceCount;
+}
+
+G4NuclearLevel::G4NuclearLevel()
+  : _energy(0.), _halfLife(0.), _angularMomentum(0.), _nGammas(0) {
+  // G4cout << "####### Incrementing "<<Increment(1)<<G4endl;
+}
+
+G4NuclearLevel::G4NuclearLevel(const G4double energy, const G4double halfLife,
+			       const G4double angularMomentum)
+  : _energy(energy), _halfLife(halfLife), _angularMomentum(angularMomentum),
+    _nGammas(0) {
+  // G4cout << "####### Incrementing "<<Increment(1)<<G4endl;
 }
 
@@ -77,30 +92,12 @@
 			       const std::vector<double>& totalCC)
 
-{
-  _energy = energy;
-  _halfLife = halfLife;
-  _angularMomentum = angularMomentum;
-  unsigned int i;
-  for (i=0; i<eGamma.size(); i++)
-    {
-      _energies.push_back(eGamma[i]);
-      _weights.push_back(wGamma[i]);
-      _polarities.push_back(polarities[i]);
-      _kCC.push_back( kCC[i]);
-      _l1CC.push_back( l1CC[i]);
-      _l2CC.push_back( l2CC[i]);
-      _l3CC.push_back( l3CC[i]);
-      _m1CC.push_back( m1CC[i]);
-      _m2CC.push_back( m2CC[i]);
-      _m3CC.push_back( m3CC[i]);
-      _m4CC.push_back( m4CC[i]);
-      _m5CC.push_back( m5CC[i]);
-      _nPlusCC.push_back( nPlusCC[i]);
-      _totalCC.push_back( totalCC[i]);
-    }
-  _nGammas = _energies.size();
-  MakeProbabilities();
-  MakeCumProb();
- // G4cout << "####### Incrementing "<<Increment(1)<<G4endl;
+  : _energies(eGamma), _weights(wGamma), _polarities(polarities),
+     _kCC(kCC), _l1CC(l1CC), _l2CC(l2CC), _l3CC(l3CC),
+    _m1CC(m1CC), _m2CC(m2CC), _m3CC(m3CC), _m4CC(m4CC), _m5CC(m5CC),
+    _nPlusCC(nPlusCC), _totalCC(totalCC),
+    _energy(energy), _halfLife(halfLife), _angularMomentum(angularMomentum)
+{
+  Finalize();
+  // G4cout << "####### Incrementing "<<Increment(1)<<G4endl;
 }
 
@@ -255,5 +252,12 @@
   return;
 }
- 
+
+
+void G4NuclearLevel::Finalize() {
+  _nGammas = _energies.size();
+  MakeProbabilities();
+  MakeCumProb();
+}
+
 
 void G4NuclearLevel::MakeProbabilities()
@@ -261,15 +265,15 @@
   G4double sum = 0.;
   G4int i = 0;
-  for (i=0; i<_nGammas; i++)
-    {
-      sum += _weights[i]*(1+_totalCC[i]);
+  for (i=0; i<_nGammas; i++) {
+    sum += _weights[i]*(1.+_totalCC[i]);
+  }
+
+  if (sum <= 0.) _prob.resize(_nGammas, 1./_nGammas);	// Fast fill
+  else {
+    _prob.reserve(_nGammas);
+    for (i=0; i<_nGammas; i++) {
+      _prob.push_back(_weights[i]*(1.+_totalCC[i])/sum);
     }
-
-  for (i=0; i<_nGammas; i++)
-    {
-      if (sum > 0.) { _prob.push_back(_weights[i]*(1+_totalCC[i])/ sum); }
-      else { _prob.push_back(1./_nGammas); }
-    }
-  return;
+  }
 }
 
@@ -277,19 +281,17 @@
 void G4NuclearLevel::MakeCumProb()
 {
-  if (_nGammas > 0)
-    {
-      G4double sum = _prob[0];
-      _cumProb.push_back(sum);
-      
-      G4int i = 0;
-      for (i=1; i<_nGammas; i++)
-	{
-	  sum += _prob[i];
-          _cumProb.push_back(sum);
-	}
-    }
-  return;
-}
-
-
-
+  if (_nGammas <= 0) return;
+
+  _cumProb.reserve(_nGammas);
+
+  G4double sum = _prob[0];
+  _cumProb.push_back(sum);
+  
+  for (G4int i=1; i<_nGammas; i++) {
+    sum += _prob[i];
+    _cumProb.push_back(sum);
+  }
+}
+
+
+
